﻿using Infragistics;
using Infragistics.Controls.Grids;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Grid_ConditionalFormating
{
    /// <summary>
    /// Interaction logic for TabItem1.xaml
    /// </summary>
    public partial class TabItem1 : UserControl
    {
        private ObservableCollection<Data> source;

        public TabItem1()
        {
            InitializeComponent();
            Grid.Rows.CollectionChanged += GridRowsCollectionChanged;
        }

            public ObservableCollection<Data> Source
        {
            get
            {
                return source;
            }
            set
            {
                source = value;
                Grid.ItemsSource = value;
                ApplyLayout();
                AddConditionalFormatting();
                
            }
        }

        private int i = 0;
        private void GridRowsCollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            if(Grid.Rows != null)
            {
                i++;
            }
        }


        public void AddConditionalFormatting()
        {
            var yellowStyle = new Style(typeof(ConditionalFormattingCellControl));
            yellowStyle.Setters.Add(new Setter() { Property = ConditionalFormattingCellControl.BackgroundProperty, Value = new SolidColorBrush(Colors.Yellow) });
            yellowStyle.Setters.Add(new Setter() { Property = ConditionalFormattingCellControl.AltBackgroundProperty, Value = new SolidColorBrush(Colors.Yellow) });
            yellowStyle.Setters.Add(new Setter() { TargetName = "CellDisplay", Property = TextBlock.ForegroundProperty, Value = new SolidColorBrush(Colors.White) });


            Grid.ConditionalFormattingSettings.AllowConditionalFormatting = true;
            TextColumn stateTextColumn = Grid.Columns["Name2"] as TextColumn;
            if (stateTextColumn != null)
            {
                stateTextColumn.ConditionalFormatCollection.Add(new NotEqualToConditionalFormatRule
                {
                    Value = "1",
                    StyleScope = StyleScope.Row,
                    ShouldRefreshOnDataChange = false,
                    RuleExecution = EvaluationStage.None,
                    StyleToApply = yellowStyle
                });
            }

        }

        private void ApplyLayout()
        {
            Grid.Columns.Clear();
            Grid.Columns.Add(new TextColumn(){HeaderText = "Name1", Key="Name1"});
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name2", Key = "Name2" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name3", Key = "Name3" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name4", Key = "Name4" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name5", Key = "Name5" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name6", Key = "Name6" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name7", Key = "Name7" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name8", Key = "Name8" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name9", Key = "Name9" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name10", Key = "Name10" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name11", Key = "Name11" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name12", Key = "Name12" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name13", Key = "Name13" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name14", Key = "Name14" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name15", Key = "Name15" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name16", Key = "Name16" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name17", Key = "Name17" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name18", Key = "Name18" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name19", Key = "Name19" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name20", Key = "Name20" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name21", Key = "Name21" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name22", Key = "Name22" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name23", Key = "Name23" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name24", Key = "Name24" });
            Grid.Columns.Add(new TextColumn() { HeaderText = "Name25", Key = "Name25" });
        }
    }
}
